/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#include <stdio.h>
#include "entity.h"
#include "rlimage.h"
#include "smemory.h"
#include "dafs.h"


static iDAFSError 
rotem(iImagePtr np,int4 i,int4 st,int4 end,int4 initsize)
{
	int4 j,s;
	RlLinePtr nl;
	short *temp;
	
	nl = &np->d.im.rl[st];
	for (j=st;j<end;nl++,j++) {
		s = nl->size-1;
		if ((s >= 0) && (nl->run[s].dn == i))
			nl->run[s].dn++;
		else {
			if (s+2 >= nl->asize) {
				temp = (short *) smrealloc(nl->code,SL + (ST * (nl->asize+initsize)));
				if (!temp) return MallocFailError;
				nl->asize += initsize;
				nl->code=temp;
				nl->run = (transition*)&nl->code[1];
			}
			nl->size++;
			s++;
			nl->run[s].up = i;
			nl->run[s].dn = i+1;
		}
	}
	return DAFSOK;
}

iDAFSError 
rotimg(iImagePtr sp, iImagePtr np, int amt,int initsize)
{
	RlLinePtr sr,nl;
	transition *t;
	int4 i,j,s;
	iDAFSError e;
	
	if (amt < 0) {
		sr = &sp->d.im.rl[sp->height - 1];
		for (i=0;i<sp->height;i++,sr--) {
			t = sr->run;
			while (t->up >= 0) {
				if (e = rotem(np,i,t->up,t->dn,initsize))
					return e;
				t++;
			}
		}
	} else {
		sr = sp->d.im.rl;
		for (i=0;i<sp->height;i++,sr++) {
			t = sr->run;
			while (t->up >= 0) {
				if (e = rotem(np,i,sp->width - t->dn,sp->width - t->up,initsize))
					return e;
				t++;
			}
		}
	}
	nl = np->d.im.rl;
	for (i=0;i<np->height;nl++,i++) {
		s = nl->size;
		j = s && nl->run[s-1].dn == np->width;
		if (j) s--;
		nl->size = nl->asize = s + 2;
		nl->code = (short*)smrealloc(nl->code,SL + (ST * nl->asize));
		if (!nl->code) return MallocFailError;
		nl->run = (transition*)&nl->code[1];
		if (!j) nl->run[s].up = np->width;
		nl->run[s].dn = np->width;
		nl->run[s+1].up = -1;
	}
	return DAFSOK;
}
