#include "entity.h"
#include "dafs.h"

int  count, trigger;

static void ClearID(const iEntityPtr me)
{
	iEntityPtr cur;
	
	if (me->data->im)
		me->data->im->id = 0;
	for (cur = i_GetChildEntity(me);cur;cur = i_GetNextEntity(cur))
		ClearID(cur);
}
static int compare_boxes(iEntityPtr one, iEntityPtr two)
{
	int e=0, i;
	iOrthogonPtr this, that;
	
	this = one->data->brdr;
	that = two->data->brdr;
	if ((!this && that)||(!that && this))
		e=1;
	else
	 if (this){
		if (this->n != that->n)
			e=1;
		else 
			for (i=0; i<this->n; i++){
				if (this->point[i].x != that->point[i].x)
					e=1;
				if (this->point[i].y != that->point[i].y)
					e=1;
			}
		

		}
	return e;
}

static int compare_RLimage(iImagePtr image1, iImagePtr image2, int skip)
{
	int e=0, index=0;
	iRl RLimage1, RLimage2;
	
	RLimage1 = image1->d.im;
	RLimage2 = image2->d.im;
	
	if (RLimage1.xmul   != RLimage2.xmul)   e=1;
	if (RLimage1.ymul   != RLimage2.ymul)   e=1;
	if (RLimage1.rot    != RLimage2.rot)    e=1;
	if (RLimage1.ymul   != RLimage2.ymul)   e=1;
	if (RLimage1.x   != RLimage2.x)   e=1;
	if (RLimage1.y   != RLimage2.y)   e=1;
	if (RLimage1.w   != RLimage2.w)   e=1;
	if (RLimage1.h   != RLimage2.h)   e=1;
	
	if (skip) {
		if (((!RLimage1.next) && (RLimage2.next)) ||
			((RLimage1.next) && (!RLimage2.next))) e = 1;
		if (((!RLimage1.prev) && (RLimage2.prev)) ||
			((RLimage1.prev) && (!RLimage2.prev))) e = 1;
	}	
	for (index=0;!e && index<image1->height; index++){
		if (RLimage1.rl[index]->size != RLimage2.rl[index]->size) {
			e=1;
			break;
		}
		if (RLimage1.rl[index]->asize != RLimage2.rl[index]->asize) {
			e=1;
			break;
		}
		if (RLimage1.rl[index]->last != RLimage2.rl[index]->last) {
			e=1;
			break;
		}

		if (memcmp(	RLimage1.rl[index],
						RLimage2.rl[index],
						RLimage1.rl[index]->size)) {
			e=1;
			break;
		}
	}	
	return e;
}
int compare_image(iImagePtr one_image, iImagePtr two_image, int skip)
{	
	int e=0,i;
	
	if ((one_image) && (two_image)){
		if (one_image->id) return 0; 
		one_image->id=1;
		two_image->id=1; 
		if ((one_image->type    != two_image->type)) 	e=1;
		if ((one_image->use     != two_image->use)) 		e=1;
		if ((one_image->height  != two_image->height)) 	e=1;
		if ((one_image->width   != two_image->width)) 	e=1;
		if ((one_image->prefmag != two_image->prefmag)) e=1;
		if ((one_image->dpi     != two_image->dpi)) 		e=1;
		
		if (!e) { 
			switch(one_image->type) {
				case BitMap:  if (one_image->d.bm.dataWidth != two_image->d.bm.dataWidth) {
										e=1;
										break;
									}
									if (memcmp(	one_image->d.bm.data, 
													two_image->d.bm.data, 
													one_image->height * one_image->d.bm.dataWidth)) {
										e=1;
										break;
									}
									break;
									
				case Image:		if (compare_RLimage(one_image, two_image, 0)) e=1;
									break;
											
				case Raw:		if (one_image->d.rw.data_length != two_image->d.rw.data_length) {
										e=1; 
										break;
									}
									if (one_image->d.rw.rowsinstrip != two_image->d.rw.rowsinstrip){
										e=1;
										break;
									}
									if (one_image->d.rw.num_strips != two_image->d.rw.num_strips){
										e=1;
										break;
									}
									if (!e){
										for(i=0; i<one_image->d.rw.num_strips; i++){
											if
											(one_image->d.rw.strip_lengths[i]!=two_image->d.rw.strip_lengths[i]){
												e=1;
												break;
											}
										}
									}
									if (memcmp(one_image->d.rw.data,two_image->d.rw.data, one_image->d.rw.data_length)) {
										e=1; 
										break;
									}
									if (one_image->d.rw.comp != two_image->d.rw.comp) {
										e=1;
										break;
									}
									break;

				default:			e=1;  /* unexpected data type */
									break;
			}
		}	
	}
	else
		if ((one_image) || (two_image))
		e=1;
	return e;
}

static int compare_prop(iEntityPtr one, iEntityPtr two)
{
	int e=0, i;
	iPropPtr one_props, two_props;
	iPData one_data, two_data;
	
	if ((one->data->props) && 
			(two_props = i_FindProperty(two, i_GetPropertyName(one->data->props)))){
		one_props = one->data->props;
#if 0
		if	((!one_props->next && two_props->next) || 
			(one_props->prev && !two_props->next)) 			e=1;
		if	((!one_props->prev && two_props->prev) || 
			(one_props->prev && !two_props->prev)) 			e=1;
		if	(strcmp(one_props->name,two_props->name)) 		e=1;
#endif

			one_data = one_props->data;
			two_data = two_props->data;
			if (one_data.type != two_data.type) e=1;
			if (one_data.size != two_data.size) e=1;
			
			switch (one_props->data.type) {
				case iPUserPtr:
				case iPBool:
				case iPLong:		if (one_data.val.i != two_data.val.i) e=1;
									break;
				
				case iPString: if (strcmp(one_data.val.s, two_data.val.s));
									break;
			
				case iPUserData:	if (memcmp(one_data.val.v, two_data.val.v, one_data.size))
											e=1;
										break;
										
				default:		break;
			}
		
	}
	else
		if ((one->data->props) || (two->data->props))
		e=1;
	return e;
}

static int compare_posset(iDataPtr one_data, iDataPtr two_data)
{

	int e=0, num, i;
	iPosSet choices;
	
	switch(one_data->dt) {
		case iDString:	if (strcmp(one_data->d.text, two_data->d.text)) e=1;
							break;
		case iDPosSet:	if (num = one_data->num) {
								for (i=0;i<num;i++){
									if (one_data->d.posp[i].chr != two_data->d.posp[i].chr) e=1;
									if (one_data->d.posp[i].conf != two_data->d.posp[i].conf) e=1;
								}
							}
							break;
		
		case iDUserData:if (num = one_data->num) {
								for (i=0;i<num;i++)
									/*if (one_data->d.user[i] != two_data->d.user[i]) e=1*/;
							}
							break;
		
		case iD1PosSet: if ((one_data->d.pos.chr != two_data->d.pos.chr) ||
								(one_data->d.pos.conf != two_data->d.pos.conf)) e=1;
							break;
		default:	break;
	}
	return e;
}
							
		
static int compare_a_entity(iEntityPtr one, iEntityPtr two)
{
	int e=0, index;
	
	if ((!(one->next) && (two->next)) || ((one->next) && !(two->next))) e=1;
	if ((!(one->prev) && (two->prev)) || ((one->prev) && !(two->prev))) e=2;
	if ((!(one->prdata) && (two->prdata)) || ((one->prdata) && !(two->prdata))) e=3;
	if (one->num != two->num) e=4;
	else
		for (index=0;index<one->num;index++)
			if (one->whichpos[index] != two->whichpos[index]) e=4;

	if ((one->data) && (two->data)){		
		if (one->data->ct != two->data->ct) e=5;
		if (compare_boxes(one, two)) e=6;
		if ((!(one->data->child) && (two->data->child)) ||
			((one->data->child) && !(two->data->child))) e=7;
			
		if (one->data->use != two->data->use) e=8;
		if (compare_image(one->data->im, two->data->im, 0)) e=9;
		if (compare_prop(one, two)) e=10;
		
		if ((one->data->num != two->data->num)) e=11;
		if (strcmp(i_GetType(one), i_GetType(two))) 
			e=12;
		else
			if (compare_posset(one->data, two->data)) 
				e=13;
	}
	return e;
}
static int CompareEntitys(iEntityPtr zig, iEntityPtr zag)
{
	iEntityPtr zigger, zagger;	

	count++;
	trigger = compare_a_entity(zig, zag);
	zigger = i_GetChildEntity(zig);
	zagger = i_GetChildEntity(zag);
	
	while (zigger && zagger && !trigger) {
		trigger = CompareEntitys(zigger, zagger);
		zigger = i_GetNextEntity(zigger);
		zagger = i_GetNextEntity(zagger);
	}
	return trigger;

}

int i_CompareEntitys(iEntityPtr zig, iEntityPtr zag)
{
	int e;
	
	count=0;
	trigger=0;
	ClearID(zig);
	ClearID(zag);
	e = CompareEntitys( zig, zag);
	ClearID(zig);
	ClearID(zag);
	if (e) e = count;  
	return e;
}
	
