
/*
 * Copyright (c) 1995 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _ChooseDialog_h_
#define _ChooseDialog_h_

/*
// a Sui Generis object
*/

struct stringVoidPtrMap;
struct DLList;

typedef void (*ChooseFunction)(void *user_data, int changed);
#include "Dialog.h" // we are subclassed



class ChooseDialog : public Dialog {
  private:
	ChooseFunction choose_function; // a backpointer
	void *user_data; // a backpointer

	stringVoidPtrMap *map;
	int option_mask;
	int type_mask;
	int flagged;
	int not_flagged;
public:	
	ChooseDialog(MainWindow *main_window, Widget app_shell, 
			ChooseFunction choose_function, void *user_data);
	~ChooseDialog();
	/*virtual*/ void create();
	
	void setTypes(DLList *l);
	void setOptions(DLList *l);
	void setFlags(DLList *l);
	void choose(iEntityPtr entity, DLList *l_return);
	void _choose(iEntityPtr entity, DLList *l_return, int *parent_flag);
	int qualify(iEntityPtr entity,int *parent_flagged);

	// respond to certain x windows things indirectly
	void applyPushed();
};

#endif
