
/*
 * Copyright (c) 1995 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

/*
// base class for Dialogs
*/

#include "rafport.h"
#include "illum.h"

#include <X11/Xutil.h>

#include <Xm/MwmUtil.h>

#include "misc/color.h"
#include "misc/XArg.h"
#include "smemory.h"

#include "Dialog.h"


Dialog::Dialog(MainWindow *input_mw, Widget input_app_shell)
	: mw(input_mw),
	  app_shell(input_app_shell),
	  dialog(0)
{
}

Dialog::~Dialog()
{
	if (this->dialog){
		XtDestroyWidget(this->dialog);
		this->dialog=0;
	}
}

void
Dialog::hide()
{
	if(this->dialog && this->managedP())
	   XtUnmanageChild(this->dialog);
}

void
Dialog::show()
{
	if(this->dialog == 0)
		this->create();
	
	XtManageChild(this->dialog);
	Widget popper;
	popper = XtParent(this->dialog);
	XtPopup(popper, XtGrabNone);
	
	XMapRaised(XtDisplay(popper), XtWindow((popper)));
}

			
int
Dialog::managedP()
{
	return this->dialog && XtIsManaged(this->dialog);
}
