
/*
 * Copyright (c) 1995 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

/*
// bogus 
// geometry management isn't what I want it to be
//    what is the scrolled window doing?
// has to respond to changing the type by converting the data
// should make pos set s variable size
// should make glyph a pos set of 1
// must add
//    confidence
//    string
//    unistring
//    int
// for user data should display a pointer
*/

#include "rafport.h"
#include "illum.h"

#include "c-type.h"
#include "smemory.h"

#include <Xm/DialogS.h>
#include <X11/Xutil.h>

#include <Xm/Text.h>
#include <Xm/Label.h>
#include <Xm/TextF.h>
#include <Xm/Form.h>
#include <Xm/ScrolledW.h>
#include <Xm/MessageB.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/PanedW.h>
#include <Xm/Frame.h>
#include <Xm/Separator.h>


#include "misc/misc.h"
#include "rafutil.h"
#include "ucs.h" 
#include "misc/XArg.h"

#include "keyboard/KeyBoard.h"
#include "Application.h"
#include "MainWindow.h"
#include "Document.h"

#include "EntContentDialog.h"
#include "IllEditor.h"
#include "IllCanvas.h"
#include "misc/ScrollWindow.h"

/* because Motif include files aren't understood by GDB/G++ */
struct xmtb{
    char *ptr;                  /* Pointer to data. */
    int length;                 /* Number of bytes of data. */
    XmTextFormat format;       /* Representations format */
};

typedef struct xmtb xmtb;

struct xmtvcbs
{
    int reason;
    XEvent  *event;
    Boolean doit;
    long currInsert, newInsert;
    long startPos, endPos;
    xmtb *text;
};

typedef struct xmtvcbs xmtvcbs;

static MenuItem types[] = {
	{ 0, "No Content", &xmPushButtonGadgetClass, 'N', 
	  NULL, NULL, (XtCallbackProc) cdSetType, (void *) iDNo, NULL },
	{ 0, "Choices", &xmPushButtonGadgetClass, 'C', 
	  NULL, NULL, (XtCallbackProc) cdSetType, (void *) iDPosSet, NULL },
	{ 0, "String", &xmPushButtonGadgetClass, 'S', 
	  NULL, NULL, (XtCallbackProc) cdSetType, (void *) iDString, NULL },
	{ 0, "Glyph", &xmPushButtonGadgetClass, 'G', 
	  NULL, NULL, (XtCallbackProc) cdSetType, (void *) iD1PosSet, NULL },
	{ 0, "User Data", &xmPushButtonGadgetClass, 'D', 
	  NULL, NULL, (XtCallbackProc) cdSetType, (void *) iDUserData, NULL },
	{ 0, "Confidence", &xmPushButtonGadgetClass, 'o', 
	  NULL, NULL, (XtCallbackProc) cdSetType, (void *) iDConf, NULL },
	{ 0, "Long", &xmPushButtonGadgetClass, 'I', 
	  NULL, NULL, (XtCallbackProc) cdSetType, (void *) iDShort, NULL },
	{ 0, "Unicode String", &xmPushButtonGadgetClass, 'U', 
	  NULL, NULL, (XtCallbackProc) cdSetType, (void *) iDUString, NULL },
	NULL_MENU,	
};



EntContentDialog::EntContentDialog(MainWindow *input_mw, 
								   Widget input_app_shell, 
								   XtAppContext(input_app_context))
	: ContentDialog(input_mw, input_app_shell, input_app_context,
					types,
					MAX_DTAG, 
					"Entity Contents"),
	  entity(0),
	  integer_confidence_widget(0),
	  integer_widget(0),
	  string_widget(0)
{		
	int i;
	
	for(i = 0; i < NUM_POSSETS; i++){
		this->possets[i].value_widget = 0;
		this->possets[i].confidence_widget = 0;
	}
}


EntContentDialog::~EntContentDialog()
{
	delete uni;
}


void
EntContentDialog::createCustom()
{
	this->createPosset();
	this->createOthers();
	XtUnmanageChild(this->menu[iD1PosSet].result);
}


void
EntContentDialog::createPosset()
{
	XArg args;
	XmString xms;
	Widget rc;
	Widget label;
	XArg& value_args = args;
	XArg conf_args;

	args.reset();
	args.setArg(XmNorientation, XmHORIZONTAL);
	args.setArg(XmNpacking, XmPACK_COLUMN);
	args.setArg(XmNnumColumns, NUM_POSSETS + 1);
	rc = XmCreateRowColumn(this->frame, "rc", 
						   args.getArgs(), args.getSize());

	args.reset();
	xms = XmStringCreateLocalized("Value");
	args.setArg(XmNlabelString, xms);
	label = XmCreateLabel(rc, "label",
						  args.getArgs(), args.getSize());
	XmStringFree(xms);
	XtManageChild(label);

	args.reset();
	xms = XmStringCreateLocalized("Confidence");
	args.setArg(XmNlabelString, xms);
	label = XmCreateLabel(rc, "label",
						  args.getArgs(), args.getSize());
	XmStringFree(xms);
	XtManageChild(label);
	
	for(int i = 0; i < NUM_POSSETS; i++){
		value_args.reset();
		conf_args.reset();

		value_args.setArg(XmNmaxLength, 4);
		value_args.setArg(XmNcolumns, 4);
		value_args.setArg(XmNvalue, "");
		value_args.setArg(XmNuserData, i);

		conf_args.setArg(XmNmaxLength, 10);
		conf_args.setArg(XmNcolumns, 10);
		conf_args.setArg(XmNvalue, "0");
		conf_args.setArg(XmNuserData, i);

		this->possets[i].value_widget = XmCreateTextField(rc, "ps", value_args.getArgs(), value_args.getSize());
		this->possets[i].confidence_widget = XmCreateTextField(rc, "ps", conf_args.getArgs(), conf_args.getSize());
		XtAddCallback(this->possets[i].value_widget, XmNmodifyVerifyCallback,
					  (XtCallbackProc) verify_value, this);
		
		XtAddCallback(this->possets[i].confidence_widget, XmNmodifyVerifyCallback,
					  (XtCallbackProc) verify_short, this);
		XtManageChild(this->possets[i].value_widget);
		XtManageChild(this->possets[i].confidence_widget);
	}

	//XtManageChild(rc);

	this->content_widgets[iDPosSet] = rc;
	this->content_widgets[iD1PosSet] = rc;
}

void
EntContentDialog::createOthers()
{
	XArg args;
	XmString xms;
	Widget label;
	Widget text;
	int i;

	// No data
	xms = XmStringCreateLocalized("No Content");
	args.reset();
	args.setArg(XmNlabelString, xms);
	label = XmCreateLabel(this->frame, "label",
				  args.getArgs(), args.getSize());
	XmStringFree(xms);
	this->content_widgets[iDNo] = label;

	// String
	args.reset();
	args.setArg(XmNeditMode, XmMULTI_LINE_EDIT);
	args.setArg(XmNheight, 90);
	text = XmCreateScrolledText(this->frame, "text",
								args.getArgs(), args.getSize());
	this->string_widget = text;
	this->content_widgets[iDString] = XtParent(text);
       	XtManageChild(text);
	XtUnmanageChild(XtParent(text));

	Widget rc;

	// Integer
	args.reset();
	args.setArg(XmNorientation, XmHORIZONTAL);
	args.setArg(XmNpacking, XmPACK_COLUMN);
	args.setArg(XmNnumColumns, 3);
	rc = XmCreateRowColumn(this->frame, "rc", 
						   args.getArgs(), args.getSize());

	args.reset();
	xms = XmStringCreateLocalized("Long:");
	args.setArg(XmNlabelString, xms);
	label = XmCreateLabel(rc, "label",
						  args.getArgs(), args.getSize());
	XmStringFree(xms);
	XtManageChild(label);

	args.reset();
	args.setArg(XmNmaxLength, 10);
	args.setArg(XmNcolumns, 10);
	args.setArg(XmNvalue, "0");
	args.setArg(XmNuserData, i);

	this->integer_widget = XmCreateTextField(rc, "ps", 
											 args.getArgs(), args.getSize());
	XtAddCallback(this->integer_widget, XmNmodifyVerifyCallback,
				  (XtCallbackProc) verify_short, this);
	XtManageChild(this->integer_widget);


	args.reset();
	xms = XmStringCreateLocalized("Confidence:");
	args.setArg(XmNlabelString, xms);
	label = XmCreateLabel(rc, "label",
						  args.getArgs(), args.getSize());
	XmStringFree(xms);
	XtManageChild(label);

	args.reset();
	args.setArg(XmNmaxLength, 10);
	args.setArg(XmNcolumns, 10);
	args.setArg(XmNvalue, "0");
	args.setArg(XmNuserData, i);

	this->integer_confidence_widget = XmCreateTextField(rc, "ps", 
											 args.getArgs(), args.getSize());
	XtAddCallback(this->integer_confidence_widget, XmNmodifyVerifyCallback,
				  (XtCallbackProc) verify_short, this);
	XtManageChild(this->integer_confidence_widget);


	this->content_widgets[iDShort] = rc;

	// this guy will get the weird growth
	args.reset();
	xms = XmStringCreateLocalized("");
	args.setArg(XmNlabelString, xms);
	label = XmCreateLabel(rc, "label",
						  args.getArgs(), args.getSize());
	XmStringFree(xms);
	XtManageChild(label);


	// confidence
	args.reset();
	xms = XmStringCreateLocalized("Confidence supported in future release");
	args.setArg(XmNlabelString, xms);
	label = XmCreateLabel(this->frame, "label",
						  args.getArgs(), args.getSize());
	XmStringFree(xms);
	//XtManageChild(label);

	this->content_widgets[iDConf] = label;

	// unicode string
	args.reset();
	Widget uni_frame = XtVaCreateWidget("uni_frame", 
											   xmScrolledWindowWidgetClass, 
											   this->frame,
											   XmNheight, 90,
											   XmNscrollingPolicy, XmAUTOMATIC,
											   NULL);
	ScrollWindow *sw;
	sw = new ScrollWindow(uni_frame);
	IllCanvas *canvas;
	canvas = new IllCanvas(sw, this->app_context, 
						   uni_frame, 0, 0, this->mw);
	uni = new IllEditor(canvas, TRUE, this->mw);
	canvas->setClient(uni);
	//uni = new IllEditor(sw, this->mw, uni_frame, TRUE);
	Widget uni_widget = uni->getWidget();
	// bogus -- wrong
	XtVaSetValues(uni_widget, 
				  XmNheight, 1000,
				  XmNwidth, 1000,
				  NULL);
       	XtManageChild(uni_widget);
	XtUnmanageChild(uni_frame);

	this->content_widgets[iDUString] = uni_frame;
}

void
EntContentDialog::emptyDialog()
{
	int i;

	XmTextSetString(this->string_widget, "");

	for (i=0;i<NUM_POSSETS;i++) {
		XmTextFieldSetString(this->possets[i].value_widget, 
							 "");
		XmTextFieldSetString(this->possets[i].confidence_widget, 
							 "0");
	}

	XmTextFieldSetString(this->integer_widget, "0");
	XmTextFieldSetString(this->integer_confidence_widget, "0");
	uni->setString((iUCode *) "\0\0");
}


void
EntContentDialog::putInDialog()
{
	iPosSetPtr ps;
	int2 valid;
	char pos_buf[8];
	char glyph_buf[6];
	int i;
	char *s;
	char buf[10];
	int value;
	short conf;

	if(this->entity == 0)
		return;

	this->emptyDialog();

	iDTag t =  i_GetEDataType(this->entity);

	switch(t){
	case iDPosSet:
	case iD1PosSet:
		ps = i_GetPosSet(this->entity, &valid);
		
		if(valid > NUM_POSSETS)
			valid = NUM_POSSETS;
		
		for(i = 0; i < valid; i++) {
			iUCode c = ps[i].chr;
			if(c < 128 && isprint(c)) {
				sprintf(glyph_buf, "%c", (char) c);
			} else {
				sprintf(glyph_buf, "%x", (int) c);
			}
			
			sprintf(pos_buf,"%d", ps[i].conf);
			XmTextFieldSetString(this->possets[i].value_widget, 
								 (char *) glyph_buf);
			XmTextFieldSetString(this->possets[i].confidence_widget, 
								 (char *) pos_buf);
		}
		break;
	case iDString:
		s = (char*)i_GetText(this->entity,0);
		XmTextSetString(this->string_widget, s);
		break;
	case iDConf:
		break;
	case iDShort:
		value = i_GetShort(this->entity, &conf);
		sprintf(buf, "%d", value);
		XmTextFieldSetString(this->integer_widget, buf);
		sprintf(buf, "%d", conf);
		XmTextFieldSetString(this->integer_confidence_widget, buf);
		break;
	case iDUString:
		uni->setString(i_GetUText(this->entity,0));
		break;
	default:
		break;
	}
}


void
EntContentDialog::getFromDialog()
{
	int i;
	int num_fields;
	iPosSetPtr ps;	
	char pos_buf[8];
	int j;
	int value;
	char *s;
	iUCode *us;
	int conf;

	if(entity == 0)
		return;
	iDTag t = (iDTag)this->tag;

	switch(t){
	case iDNo:
		i_SetNoData(entity);
		break;
	case iDPosSet:
	case iD1PosSet:
		num_fields = 0;
		for(i = 0; i < NUM_POSSETS; i++){
			if(strlen(XmTextFieldGetString(this->possets[i].value_widget)) != 0)
				num_fields++;
		}
		
		if(num_fields == 0) {
			// clear the entity
		} else {
			ps = (iPosSetPtr) smalloc(sizeof(iPosSet) * num_fields);
			// allocate big enough posset
			j = 0;
			for(i = 0; i < NUM_POSSETS; i++) {
				strcpy(pos_buf, 
					   XmTextFieldGetString(this->possets[i].value_widget));
				
				if(strlen(pos_buf)){
					char *s;
					// add to posset
					s = XmTextFieldGetString(this->possets[i].confidence_widget);
					
					if(strlen(pos_buf) == 1)
						ps[j].chr  = pos_buf[0];
					else {
						int c;
						sscanf(pos_buf, "%x", &c);
						ps[j].chr = c;
					}
					int conf;
					if (strncmp(s,"0x",2))
						sscanf(s, "%d", &conf);
					else sscanf(&s[2],"%x",&conf);
					ps[j].conf = conf;
					j++;
				}
			}
			i_SetPosSet(entity, num_fields, ps);
		}
		
		break;
	case iDShort:
		s = XmTextGetString(this->integer_widget);
		if (strncmp(s,"0x",2))
			sscanf(s, "%d", &value);
		else sscanf(&s[2],"%x",&value);
		s = XmTextGetString(this->integer_confidence_widget);
		if (strncmp(s,"0x",2))
			sscanf(s, "%d", &conf);
		else sscanf(&s[2],"%x",&conf);
		i_SetShort(entity, value, conf);
		break;
	case iDConf:
		return;
		break;
	case iDString:
		i_SetText(entity, XmTextGetString(this->string_widget),0);
		break;
	case iDUString:
		us = uni->getString();
		i_SetUText(entity, us,0);
		smfree(us);		
		break;
	default:
		return;
		break;
	}

	this->mw->document->setDirty();
}

/*
// put the usual event loop in here
*/
int
EntContentDialog::showModal(iEntityPtr input_entity)
{
	int t;

	this->entity = input_entity;

	t = i_GetEDataType(entity);	
	if(t == iD1PosSet)
		t = iDPosSet;
	this->setType(t);

	this->ContentDialog::showModal();
	return this->changed;
}

