
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _HE_h_
#define _HE_h_

#include "illum.h"
#include "text/EntityFace.h"

class HE;
typedef HE *HEPtr;

class HE : public EntityFace {
  public:
	int y,ind,show;
	
	// entity is in EntityFace
public:
	HE(Page *user_data, iEntityPtr entity,int ypos,int showval,int lev);
	virtual ~HE();
public:
	void redraw();
	int inTri(int x);
	void drawAnEntity(Display *display,Pixmap pixmap,GC gc,
		int cw,int ch,int asc,int maxlen);
	/*virtual*/ void deleteAndUpdate();
	/*virtual*/ void deleteCheap();
	
	/* callbacks -- EntityFace virtuals */
	/*virtual*/ void create();
	
	/*virtual*/ void willUpdate();
	/*virtual*/ void update();
	
	/*virtual*/ void willMove();
	/*virtual*/ void move();
	
	/*virtual*/ void destroy();
	
	/*virtual*/ void select();
	/*virtual*/ void unSelect();
	
	/*virtual*/ void recognize();
	
	/*virtual*/ MainWindow *getMainWindow();
	
	friend class HierPage;
};

#endif


