
#ifndef _LTEPage_h_
#define _LTEPage_h_

#include "Page.h"
#include "misc/misc.h"

class IllEditor;

class LTEPage : public Page {
private:
  IllEditor *ue;
public:
  LTEPage(Mode *input_mode, const aString& label, iEntityPtr entity);
  virtual ~LTEPage();
  void init(iEntityPtr en);

  /*virtual*/ void conditionallyInitialiseCanvas();
  /*virtual*/ void setMag(int new_mag, int old_mag);
  /*virtual*/ void _setMag(int new_mag, int old_mag);
  /*virtual*/ void redisplay(XmDrawingAreaCallbackStruct *call_data);
  /*virtual void resize(XmDrawingAreaCallbackStruct *call_data); */
  /*virtual*/ iEntityPtr findEnclosingEntity(int x, int y);
	
  /*virtual*/ void addNewEntity(iEntityPtr entity);
  
  /*virtual*/ void findNextFlagEntity();

  /*virtual*/ void prevEntity();
  /*virtual*/ void nextEntity();
  /*virtual*/ void upEntity();
  /*virtual*/ void downEntity();
	 
  /*virtual*/ void centerOnSelected(iEntityPtr entity);
  /*virtual*/ void scrollToUpperLeft(iEntityPtr entity){};
  /*virtual*/ void scrollToLowerRight(iEntityPtr entity){};
	
  // for delayed drawing
  /*virtual*/ int resizeNecessaryP();
  /*virtual*/ void drawRegionNow(iLBox box);

  /*virtual void setPicture(iLBox b); */
  /*virtual iLBox getPicture(); */
	
  /*virtual*/ int pressKey(iUCode key_value);
	
  /*virtual*/ void         pressButton(XEvent *event);
  /*virtual*/ void         releaseButton(XEvent *event);
  /*virtual*/ void         moveButton(int state, int x, int y);
	
  /*virtual*/ void manage();
  /*virtual*/ void unmanage();

  void configure();

  void processDelete(void);
};

#endif
