
/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _OOCView_h_
#define _OOCView_h_

/*
// **************************************
// This pragma kills debugging information in all files but those
// implementing the code - it is unique to g++
*/
#ifdef __GNUC__
#pragma interface
#endif

#include "View.h"

#include "aString.h"
#include "illum.h"
#include "dllist.h"
#include "pq.h"

class OOCView;
class OOCFrame;

class  OOCView : public View 
{
public:
	int ooc_type;
	int ooc_flagged;
	ViewType view_type;
	
	OOCView(MainWindow *main_window, iEntityPtr root_entity, int type, int flagged);
	virtual ~OOCView();
	
	void chooseMembers(iEntityPtr entity, 
					   DLList *);
	
	void createList(DLList *);
	void mergeInList(DLList *);
	void mergeInListFlag(DLList *m);
	
	void findChanged(DLList *candidates, DLList *changed);
	
	/*virtual*/ void createFrames(iEntityPtr root_entity);
	/*virtual*/ void configure();
	/*virtual*/ inline aString getName() { 
		if (this->view_type==vtOOC) return "OOC";
		else return "Flag";
	}
	/*virtual*/ ViewType getMode() { return this->view_type; }
	/*virtual*/ iBox getBounds(iEntityPtr entity);
	
	/*virtual*/ void addNewEntity(iEntityPtr new_entity);
	/*virtual*/ void choose();
	/*virtual*/ void centerOnSelected(iEntityPtr entity);

	/*virtual*/ void setCurrentFrame(Ref r);

	// these are so the OOC can have sub pages
	/*virtual*/ int forward();
	/*virtual*/ int back();
};

#endif 

