
/*
 * Copyright (c) 1994, 1995 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _config_h_
#define _config_h_


#define ILLUM_PREFS_FILE ".illumrc"

#define FIELD_PROP "field"
#define PAGE_PROP  "page"
#define COLOR_PROP "color"
#define VISIBLE_PROP "visible"


const char* getColor(iEntityPtr entity);
const char* getTypeColor(const char *type);
void setTypeColor(char *type, char *color);
int isVisibleSet(iEntityPtr entity);

int getField(iEntityPtr entity);
int getTypeField(const char *type);
void setTypeField(char *type, int value);

int getPage(iEntityPtr entity);
int getTypePage(const char *type);
void setTypePage(char *type, int value);

int getVisible(iEntityPtr entity);
int getTypeVisible(const char *type);
void setTypeVisible(char *type, int value);

int turn_off_others(const char *type, iEntityPtr en);
void readConfig(char *file);
void writeConfig(void);


// bogus
void disposeColorTable(void);

#endif
