

/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */
#ifndef illum_h
#define illum_h

/*
// This is where I stick miscellanous routines for illum
*/

#include <X11/Intrinsic.h>
#include <Xm/Xm.h>

#include "aString.h"
#include "dafs.h"
#include "edit.h"

#define EDITING_PROP "editing"

// bogus these should be in dafslib or something
#define FLAG_PROP "Flag"
#define ILLUM_PROP "illum"

#define NON_REC_CHAR '^'
#define NON_REC_STR "^"

// this is super annoying -- Dave has CERTCONF defined where it oughtnt
#ifdef RAF_INTERNAL
// dont mess with this John!
#include "form.h"
#include "formint.h"
#endif
#ifndef CERTCONF
#define CERTCONF 0xff  // this is the maximum confidence value
#endif

#if 1
#define KILL_TEXT_MODE
#endif

#if 1
#define IGNORE_ORS
#endif

#define NOISE_CHAR 0x01

class ViewCanvas;
class Document;
class KeyBoard;
class KeyMap;
class Application;
class SelectionManager;
class MainWindow;

class UniEdit;
class NihonEdit;

class ListDialog;
class ChooseDialog;
class ColorDialog;
class TypePrefDialog;
class SaveAsDialog;
class OpenDialog;
class EntityDialog;

class EntContentDialog;
class PropContentDialog;
class ContentDialog;

class TreePage;
class TreeMode;
class TreeElement;

class ImagePage;
class ImageMode;
class IE;

class OOCPage;
class OOCMode;
class CE;



class RTEMode;
class RTEPage;

class Page;
class Mode;
class EntityFace;

extern Application *the_application;
extern MainWindow *the_window;
extern XtAppContext global_app_context; 

iEntityPtr pickpath(iEntityPtr doc);

extern "C" void _XInitImageFuncPtrs(XImage *x_image);

#define GRAY_COLOR "gray88"


enum ModeType {
	vtIMAGE = 0,
	vtOOC,
	vtFLAG,
	vtTREE,
	vtRTE,
	NUM_MODE_TYPES
};

typedef enum ModeType ModeType;
typedef int (*EntityCheckFunc)(iEntityPtr entity);
typedef void ( *textMeasureFunction ) (const iUCode *s, int l, int *tw, int *th, int *ascent);

extern char *global_pick_choice;
extern char *global_pick_which;

iDAFSError entityCB(iMess m, void *user, iEntityPtr entity);

// this is a bit bogus: if a new message is added, this must change
#define mSelect     (mDestImg + 1)
#define mUnSelect   (mDestImg + 2)
// bogus still used? does it work
#define mRecognize   (mDestImg + 3)

void disableCallbacks();
void enableCallbacks();

void initializeText();

#ifdef RAF_INTERNAL
extern char *ellipse_file;
void initializeRecognition();

#define GROTYCLASS "Groty Class"
#endif

void ringTheBell();
void killContentsForSelection();

#endif
