/*
 * Copyright (c) 1994 RAF Technology
 * developed for ARPA under contract MDA 904-93-C-7219
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the names of
 * RAF Technology or ARPA  may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of RAF Technology and ARPA.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * IN NO EVENT SHALL RAF TECHNOLOGY OR ARPA  BE LIABLE FOR
 * ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
 * LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
 * OF THIS SOFTWARE.
 */

#ifndef _H_conv_
#define _H_conv_

struct TableEntry {
	char text_code;
	char name[32];
	short internal_code;
	short uni_code;
	char iso_code;
};

/*
  TEXT     CHAR 	 CALERA		Uni	Iso
  PDA      NAME	 INTERNAL	Code	Ascii  
  CHAR        	 CHAR CODE
  CODE
  ----   ----    		-----------	----	----	
  */

struct TableEntry isotable[] = {
	{ 128 ,	"Yyi",		548,	0x0457,	0xf7},
	{ 129 ,	"YYI",		549,	0x0407,	0xa7},
	{ 130 ,	"Yis/i",	497,	0x0456,	0xf6},
	{ 131 ,	"YIS/I",	498,	0x0406,	0xa6},
	{ 132 ,       " ",            0,      0,      0},
	{ 133 ,       " ",            0,      0,      0},
	{ 134 ,	"Ydja/ge_hook",	469,	0x0495,	0},
	{ 135 ,	"YDJA/ge_hook",	470,	0x0494,	0},
	{ 136 ,	"Ydze",		473,	0x0455,	0xf5},
	{ 137 ,	"YDZE",		474,	0x0405,	0xa5},
	{ 138 ,       " ",            0,      0,      0},
	{ 139 ,       " ",            0,      0,      0},
	{ 140 ,       " ",            0,      0,      0},
	{ 141 ,       " ",            0,      0,      0},
	{ 142 ,       " ",            0,      0,      0},
	{ 143 ,       " ",            0,      0,      0},
	{ 144 ,       " ",            0,      0,      0},
	{ 145 ,       " ",            0,      0,      0},
	{ 146 ,	"Bulg_ye",	558,	0x04b1,	0x0},
	{ 147 ,	"Bulg_YE",	559,	0x04b0,	0x0},
	{ 148 ,	"YE-aaU",	480,	0,	0},
	{ 149 ,	"YE-u/IO",	482,	0x0401,	0xa1},
	{ 150 ,       " ",            0,      0,      0},
	{ 151 ,       " ",            0,      0,      0},
	{ 152 ,       " ",            0,      0,      0},
	{ 153 ,       " ",            0,      0,      0},
	{ 154 ,	"Ydje",		471,	0x0452,	0xf2},
	{ 155 ,	"YNG/enge",	517,	0x04a5,	0x0},
	{ 156 ,	"YDJE",		472,	0x0402,	0xa2},
	{ 157 ,       " ",            0,      0,      0},
	{ 158 ,	"Ye-u/io",	481,	0x0451,	0xf1},
	{ 159 ,	"Ye-aaU",	479,	0,	0},
	{ 160 ,	" ",	        0,	0,	0},
	{ 161 ,	"YUU",		543,	0x04ae,	0x0},
	{ 162 ,	"YSS",		533,	0x042c,	0xcc},
	{ 163 ,	"YLJE",		512,	0x0409,	0xa9},
	{ 164 ,	"YIE/E",	496,	0x0404,	0xa4},
	{ 165,        " ",            0,      0,      0,},
	{ 166 ,	"Bulg_IU",	557,	0x046c,	0x0},
	{ 167 ,	"Yss",		532,	0x044c,	0xec},
	{ 168 ,	"YEA",		484,	0x042d,	0xcd},
	{ 169 ,	"YNJE",		519,	0x040a,	0xaa},
	{ 170 ,	"Bulg_U",	555,	0x046a,	0x0},
	{ 171 ,	"Num_symbol",	573,	0x2116,	0},
	{ 172 ,	"YJU/IU",	506,	0x042e,	0xce},
	{ 173 ,	"Serb_tch",	560,	0x045b,	0x0},
	{ 174 ,	"Yju/iu",	505,	0x044e,	0xee},
	{ 175 ,        " ",           0,      0,      0},
	{ 176 ,	"Ynje",		518,	0x045a,	0xfa},
	{ 177 ,	"Yuu",		542,	0x04af,	0x0},
	{ 178 ,	"Yje",		503,	0x0458,	0xf9},
	{ 179 ,	"Ylje",		511,	0x0459,	0xf9},
	{ 180 ,	"Yie/e",	495,	0x0454,	0xf4},
	{ 181 ,       " ",            0,      0,      0},
	{ 182 ,	"Ydzhe",	475,	0x045f,	0xff},
	{ 183 ,	"Bulg_iu",	556,	0x046d,	0x0},
	{ 184 ,	"Bulg_u",	554,	0x046b,	0x0},
	{ 185 ,	"Yea",		483,	0x044d,	0xed},
	{ 186 ,	"YZH",		553,	0x0416,	0xb6},
	{ 187 ,	"Yzh",		552,	0x0436,	0xd6},
	{ 188 ,       " ",            0,      0,      0},
	{ 189 ,       " ",            0,      0,      0},
	{ 190 ,       " ",            0,      0,      0},
	{ 191 ,       " ",            0,      0,      0},
	{ 192 ,	"YJE",		504,	0x0408,	0xa9},
	{ 193 ,	"YA",		460,	0x0410,	0xb0},
	{ 194 ,	"YB/BE",	462,	0x0411,	0xb1},
	{ 195 ,	"YC/TSE",	464,	0x0426,	0xc6},
	{ 196 ,	"YD/DE",	468,	0x0414,	0xb4},
	{ 197 ,	"YE/IE",	478,	0x0415,	0xb5},
	{ 198 ,	"YF/EF",	486,	0x0424,	0xc4},
	{ 199 ,	"YG/GE",	488,	0x0413,	0xb3},
	{ 200 ,	"YHS",		492,	0x042a,	0xca},
	{ 201 ,	"YI/II",	494,	0x0418,	0xb8},
	{ 202 ,	"YJ/SII",	500,	0x0419,	0xb9},
	{ 203 ,	"YK",		508,	0x041a,	0xba},
	{ 204 ,	"YL/EL",	510,	0x041b,	0xbb},
	{ 205 ,	"YM",		514,	0x041c,	0xbc},
	{ 206 ,	"YN",		516,	0x041d,	0xbd},
	{ 207 ,	"YO",		521,	0x041e,	0xbe},
	{ 208 ,	"YP/PE",	523,	0x041f,	0xbf},
	{ 209 ,	"YCH/CHE",	466,	0x0427,	0xc7},
	{ 210 ,	"YR/ER",	525,	0x0420,	0xc0},
	{ 211 ,	"YS",		527,	0x0421,	0xc1},
	{ 212 ,	"YT/TE",	535,	0x0422,	0xc2},
	{ 213 ,	"YU",		539,	0x0423,	0xc3},
	{ 214 ,	"YV",		545,	0x0412,	0xb2},
	{ 215 ,	"YU-u",		541,	0x040e,	0xae},
	{ 216 ,	"YHA/KHA",	490,	0x0425,	0xc5},
	{ 217 ,	"YY/YERI",	547,	0x042b,	0xcb},
	{ 218 ,	"YZ/ZE",	551,	0x0417,	0xb7},
	{ 219 ,	"Ysh",		530,	0x0448,	0xe8},
	{ 220 ,	"Ytshe",	536,	0x045b,	0xfb},
	{ 221 ,	"Ysc/shcha",	528,	0x0449,	0xe9},
	{ 222 ,	"YDZHE",	476,	0x040f,	0xaf},
	{ 223 ,       " ",            0,      0,      0},
	{ 224 ,	"Yja/ia",	501,	0x044f,	0xef},
	{ 225 ,	"Ya",		459,	0x0430,	0xd0},
	{ 226 ,	"Yb/be",	461,	0x0431,	0xd1},
	{ 227 ,	"Yc/tse",	463,	0x0446,	0xe6},
	{ 228 ,	"Yd/de",	467,	0x0434,	0xd4},
	{ 229 ,	"Ye/ie",	477,	0x0435,	0xd5},
	{ 230 ,	"Yf/ef",	485,	0x0444,	0xe4},
	{ 231 ,	"Yg/ge",	487,	0x0433,	0xd3},
	{ 232 ,	"Yhs",		491,	0x044a,	0xea},
	{ 233 ,	"Yi/ii",	493,	0x0438,	0xd8},
	{ 234 ,	"Yj/sii",	499,	0x0439,	0xd9},
	{ 235 ,	"Yk",		507,	0x043a,	0xda},
	{ 236 ,	"Yl/el",	509,	0x043b,	0xdb},
	{ 237 ,	"Ym",		513,	0x043c,	0xdc},
	{ 238 ,	"Yn",		515,	0x043d,	0xdd},
	{ 239 ,	"Yo",		520,	0x043e,	0xde},
	{ 240 ,	"Yp/pe",	522,	0x043f,	0xdf},
	{ 241 ,	"Ych/che",	465,	0x0447,	0xe7},
	{ 242 ,	"Yr/er",	524,	0x0440,	0xe0},
	{ 243 ,	"Ys",		526,	0x0441,	0xe1},
	{ 244 ,	"Yt/te",	534,	0x0442,	0xe2},
	{ 245 ,	"Yu",		538,	0x0443,	0xe3},
	{ 246 ,	"Yv",		544,	0x0432,	0xd2},
	{ 247 ,	"Yu-u",		540,	0x045e,	0xfe},
	{ 248 ,	"Yha/kha",	489,	0x0445,	0xe5},
	{ 249 ,	"Yy/yeri",	546,	0x044b,	0xeb},
	{ 250 ,	"Yz/ze",	550,	0x0437,	0xd7},
	{ 251 ,	"YSC/SHCHA",	529,	0x0429,	0xc9},
	{ 252 ,	"YTSHE",	537,	0x040B,	0xab},
	{ 253 ,	"YSH",		531,	0x0428,	0xc8},
	{ 254 ,	"YJA/IA",	502,	0x042f,	0xcf},
};
#endif

#if 0
223     Serb_TCH 	561				
132     Cyr_q 		562				
133     Cyr_Q   	563			
144     Ukr_g 		564				
145     Ukr_G 		565				
150     Rus_v 		566				
151     Rus_V 		567				
157     Cyr_bh 		568				
152     Cyr_BH		569				
153     Serb_DJE	570				
181     Cyr_h   	571				
165     Cyr_H 		572				

225     italic_Ya 	574				
227     italic_Yc 	575				
228     italic_Yd 	576				
228     roof_Yd 	577				
196     roof_YD  	578				
231     italic_Yg 	579				
232     italic_Yhs	580				
233     italic_Yi 	581				
234     italic_Yj	582				
236     italic_Yl	583				
204     italic_YL	584				
240     italic_Yp 	585				
221     italic_Ysc	586				
219     italic_Ysh 	587				
244     italic_Yt 	588				
246     italic_Yv 	589				
228     italic3_Yd 	590				
131     italic_YIS 	591				
131     italic2_Yis 	592				
#endif



