#ifndef _EntityFace_h_
#define _EntityFace_h_

/* 
// This is the main alter ego of Entities in illum
// it is located in this library
// instead of the illum directory so it can be
// shared with dafs2text.
//
// there is no implementation file because there is
// nothing to be implemented it is a virtual base class
*/


class MainWindow;
class Page;

class EntityFace {
public:
	// backpointers
	Page *page;
	iEntityPtr entity;
	
	EntityFace(Page *input_page, iEntityPtr input_entity) : page(input_page), entity(input_entity) {}
	virtual ~EntityFace() {}
	
	virtual void deleteAndUpdate() = 0;
	virtual void deleteCheap() = 0;
	
	virtual void create() = 0;
	
	virtual void destroy() = 0;
	
	virtual void willUpdate() = 0;
	virtual void update() = 0;
	
	virtual void willMove() = 0;
	virtual void move() = 0;
	
	virtual void select() = 0;
	virtual void unSelect() = 0;
	
	virtual void recognize() = 0;
	
	virtual MainWindow *getMainWindow() = 0;
};

#endif
