#include <stdio.h>
#include "RTEView.h"
#include "Rectangle.h"
#include "RTESet.h"
#include "smemory.h"

#define ROOT_X 0
#define ROOT_Y 0
#define ROOT_W 200
#define ROOT_H 200
#define ROOT_LINE_SPACE 10

static void print_rect(int i, rectangle *r)
{
	printf("Rectangle %d has x = %d, y = %d, w = %d, h = %d\n",
	        i, r->get_x(), r->get_y(), r->get_w(), r->get_h());
}

static void print_rect(char *s, rectangle *r)
{
	printf("Rectangle %s has x = %d, y = %d, w = %d, h = %d\n",
	        s, r->get_x(), r->get_y(), r->get_w(), r->get_h());
}


static void print_element_set(char *s, element_set *es)
{
	printf("element set %s:\n", s);
	int n = es->num_elements();
	for(int i=0; i<n; i++) {
		rectangle *r = es->get_element_number(i);
		print_rect(i, r);
	}
}

#define NR 100

main()
{
	s_InitLib(sCheckClobberAlways, 0, 0);

	root_element *root=0;
       	input_event_handler *ieh = NULL;
        virtual_display_device *vdd = NULL;
	child_rectangle *cr[NR];
	element_set *es=0, *es1=0;
	int i, idir;

	// ----------------------------------------------------------------------

	for(idir=0; idir<8; idir++) {
                switch(idir) {
                        case 0:
                                root = new root_element(ieh, vdd, ROOT_X, ROOT_Y,
                                                        ROOT_W, ROOT_H, TopToBottom,
                                                        LeftToRight, ROOT_LINE_SPACE);
                                break;
                        case 1:
                                root = new root_element(ieh, vdd, ROOT_X, ROOT_Y,
                                                        ROOT_W, ROOT_H, TopToBottom,
                                                        RightToLeft, ROOT_LINE_SPACE);
                                break;
                        case 2:
                                root = new root_element(ieh, vdd, ROOT_X, ROOT_Y,
                                                        ROOT_W, ROOT_H, BottomToTop,
                                                        LeftToRight, ROOT_LINE_SPACE);
                                break;
                        case 3:
                                root = new root_element(ieh, vdd, ROOT_X, ROOT_Y,
                                                        ROOT_W, ROOT_H, BottomToTop,
                                                        RightToLeft, ROOT_LINE_SPACE);
                                break;
                        case 4:
                                root = new root_element(ieh, vdd, ROOT_X, ROOT_Y,
                                                        ROOT_W, ROOT_H, LeftToRight,
                                                        TopToBottom, ROOT_LINE_SPACE);
                                break;
                        case 5:
                                root = new root_element(ieh, vdd, ROOT_X, ROOT_Y,
                                                        ROOT_W, ROOT_H, LeftToRight,
                                                        BottomToTop, ROOT_LINE_SPACE);
                                break;
                        case 6:
                                root = new root_element(ieh, vdd, ROOT_X, ROOT_Y,
                                                        ROOT_W, ROOT_H, RightToLeft,
                                                        TopToBottom, ROOT_LINE_SPACE);
                                break;
                        case 7:
                                root = new root_element(ieh, vdd, ROOT_X, ROOT_Y,
                                                        ROOT_W, ROOT_H, RightToLeft,
                                                        BottomToTop, ROOT_LINE_SPACE);
                                break;
                }
		cr[0] = new child_rectangle(0,0,7,10);
	
		printf("inserting rectangles for idir = %d ...\n", idir);
		if(!root->insert_first(cr[0])) halt("pr->insert_first(cr[0]) failed\n");
		for(i=1; i<NR; i++) {
			cr[i] = new child_rectangle(0,0,7,10);
			if(!root->insert_after(cr[i-1], cr[i])) {
				printf("root->insert_after(cr[%d],cr[%d]) failed\n", i-1, i);
				halt("program halted\n");
			}
		}
	
		printf("checking next_child ...\n");
		for(i=0; i<NR-1; i++) {
			if(root->next_child(cr[i], TRUE) != cr[i+1]) {
				printf("for i = %d, children are in wrong order\n", i);
				halt("program halted\n");
			}
		}

		printf("checking prev_child ...\n");
		for(i=1; i<NR; i++) {
			if(root->prev_child(cr[i], TRUE) != cr[i-1]) {
				printf("for i = %d, children are in wrong order\n", i);
				halt("program halted\n");
			}
		}
		printf("series of insert_afters produced expected order\n\n");

		//es = pr->get_all_children();
		const int squeeze = TRUE;
		for(i=NR/3; i < 2*NR/3; i++)
			root->delete_child(cr[i], squeeze);
	
		//es1 = pr->get_all_children();
		//print_element_set("after deleting middle third", es1);
		printf("finished series of delete_child\n");
	
		//es->delete_contents();
		//delete es;  es = 0;
		//delete es1; es1 = 0;
		delete root;  root = 0;
		for(i=0; i<NR; i++) cr[i] = 0;
	}

	// ----------------------------------------------------------------------

	s_ExitLib();
}
