

#include "rafport.h"

#include <stdio.h>

#include "rafutil.h"
#include "smemory.h"

#include "text.h"

char *
readAsciiFile(const char *file_name)
{
	int file_size;
	char *text;
	FILE *fptr;
	
	file_size = fileSizeInBytes(file_name);
	if (file_size<=0) {
		text=0;
	} else {
		text = (char *) smalloc(file_size + 3);
		
		fptr = fopen(file_name, "r");
		fread(text, 1, file_size, fptr);
		/*
		// bogus - if file is unicode and we decide to interpret is as such
		// we need to make sure that it's null terminated
		*/
		text[file_size] = '\0';
		text[file_size+1] = '\0';
		text[file_size+2] = '\0';
	}
	return text;
}


/*
// +dyn
// bogus -- assumes no nulls in the file
*/

int
dafsFileP(const char *file_name)
{
	FILE *file;
	int is_dafs = FALSE;
	char buffer[2];
	int num_read;
	
	file = fopen(file_name, "r");
	
	/* John promised me that all DAFS files would start *
	   with 2 nulls */
	if(file){
		num_read = fread(buffer, sizeof(char), 2, file);
		fclose(file);
		is_dafs = num_read == 2 && buffer[0] == '\0' && buffer[1] == '\0';
	} else {
		/* halt("couldn't open the file.\n"); */
		is_dafs=FALSE;
	}
	
	return is_dafs;
}


int
ancestorP(iEntityPtr child, iEntityPtr would_be_ancestor)
{
	for(child = i_GetParentEntity(child); child; child = i_GetParentEntity(child))
		if(child == would_be_ancestor)
			return TRUE;

	return FALSE;
}

// The application using this class must supply a function
// for measuring text.
static textMeasureFunction measureText;
extern void initializeMeasureFunction(textMeasureFunction f)
{
	measureText = f;
}
